"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var PromiseComponent = function (_Component) {
  _inherits(PromiseComponent, _Component);

  function PromiseComponent(props) {
    _classCallCheck(this, PromiseComponent);

    var _this = _possibleConstructorReturn(this, (PromiseComponent.__proto__ || Object.getPrototypeOf(PromiseComponent)).call(this, props));

    _this.state = {
      status: "pending",
      result: undefined,
      error: undefined
    };
    return _this;
  }

  _createClass(PromiseComponent, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;

      var promise = this.props.promise;


      promise.then(function (result) {
        return _this2.setState({ status: "resolved", result: result });
      }).catch(function (error) {
        return _this2.setState({ status: "rejected", error: error });
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _state = this.state,
          status = _state.status,
          error = _state.error;

      var _props = this.props,
          resolved = _props.resolved,
          rejected = _props.rejected,
          pending = _props.pending,
          props = _objectWithoutProperties(_props, ["resolved", "rejected", "pending"]);

      switch (status) {
        case "resolved":
          return typeof resolved === "function" ? _react2.default.createElement(resolved, props) : resolved;
        case "rejected":
          return typeof rejected === "function" ? _react2.default.createElement(rejected, error) : rejected;
        default:
          return typeof pending === "function" ? _react2.default.createElement(pending, props) : pending;
      }
    }
  }]);

  return PromiseComponent;
}(_react.Component);

PromiseComponent.propTypes = {
  promise: _propTypes2.default.object,
  pending: _propTypes2.default.oneOfType([_propTypes2.default.node, _propTypes2.default.func]),
  resolved: _propTypes2.default.oneOfType([_propTypes2.default.node, _propTypes2.default.func]),
  rejected: _propTypes2.default.oneOfType([_propTypes2.default.node, _propTypes2.default.func])
};

PromiseComponent.defaultProps = {
  promise: Promise.resolve(),
  pending: _react2.default.createElement("div", { children: "Pending" }),
  resolved: _react2.default.createElement("div", { children: "Resolved" }),
  rejected: _react2.default.createElement("div", { children: "Rejected" })
};

exports.default = PromiseComponent;